//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "GrdUndM.h"

//---------------------------------------------------------------------------

#pragma package(smart_init)

//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
//										Field     
//---------------------------------------------------------------------------

PACKAGE	TField*	__fastcall	DBGrid_UnderMouse_ColumnFiled	(TDBGrid *grd)
{
if (!grd || !grd->DataSource	||
	!grd->DataSource->DataSet	||
	!grd->DataSource->DataSet->Active
	)	return NULL;

int x = Mouse->CursorPos.x - grd->ClientOrigin.x;	if (x < 0 || x >= grd->ClientWidth)		return NULL;
int y = Mouse->CursorPos.y - grd->ClientOrigin.y;	if (y < 0 || y >= grd->ClientHeight)	return NULL;

TGridCoord	cell = grd->MouseCoord(x,y);

int clnidx = cell.X - (grd->Options.Contains(dgIndicator)? 1 : 0);
return (clnidx >= 0 && clnidx < grd->Columns->Count)?
	grd->Columns->Items[clnidx]->Field : NULL;
}

//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
//								      
//---------------------------------------------------------------------------

PACKAGE	Variant	__fastcall	DBGrid_UnderMouse_FieldValue
												(TDBGrid *grd
												,const AnsiString &pFieldName
												,bool AsString
												)
{
Variant	ret = ESTRorNULL;

if (!grd || !grd->DataSource	||
	!grd->DataSource->DataSet	||
	!grd->DataSource->DataSet->Active
	)	return ret;

int x = Mouse->CursorPos.x - grd->ClientOrigin.x;	if (x < 0 || x >= grd->ClientWidth)		return ret;
int y = Mouse->CursorPos.y - grd->ClientOrigin.y;	if (y < 0 || y >= grd->ClientHeight)	return ret;

TGridCoord		cell = grd->MouseCoord(x,y);
TDataSet		*ds  = grd->DataSource->DataSet;

int	rowidx = cell.Y - (grd->Options.Contains(dgTitles)   ? 1 : 0);
int clnidx = cell.X - (grd->Options.Contains(dgIndicator)? 1 : 0);
int currowidx;
{	GUM_TDBGrid *gtm = (GUM_TDBGrid*)grd;
	currowidx = gtm->GetRow() - (grd->Options.Contains(dgTitles)? 1 : 0);
}

GUM_TDataSet	*gds  = (GUM_TDataSet*)ds;
if (rowidx < 0 || rowidx >= gds->GetBufferCount())	return ret;

TField	*fld;
if (pFieldName.Trim().IsEmpty())
	fld = (clnidx >= 0 && clnidx < grd->Columns->Count)?
			grd->Columns->Items[clnidx]->Field : NULL;
else
	fld = ds->FindField(pFieldName);

if (!fld)	return ret;

if		(GUM_IsClassNameIs(ds, "TOracleDataSet"		))	ret = GUM_GetValueFromBuffer_DOA(fld, rowidx, AsString);
//else if	(GUM_IsClassNameIs(ds, "TBDEDataSet"		))	ret = GUM_GetValueFromBuffer_BDE(fld, rowidx);
//else if	(GUM_IsClassNameIs(ds, "TCustomADODataSet"	))	ret = GUM_GetValueFromBuffer_DOA(fld, rowidx);
else													ret = GUM_GetValueFromBuffer_Any(fld, rowidx, currowidx, AsString);

return ret;
}

//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
//									  DBGrid'   Hint'
//---------------------------------------------------------------------------

PACKAGE	void __fastcall	DBGrid_UnderMouse_FieldAsHint	(TDBGrid *grd, const AnsiString &pFieldName)
{
if (!GUM_GridList)	GUM_GridList= new TGUM_GridList();
GUM_GridList->Add(grd, pFieldName);
}

//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
//													 DBGrid  
//---------------------------------------------------------------------------

PACKAGE	void	__fastcall	DBGrid_UnderMouse_FieldAsHint_Stop	(TDBGrid *grd)
{
if (GUM_GridList)	GUM_GridList->Delete(grd);
}

//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
//	 
//---------------------------------------------------------------------------

bool	__fastcall	GUM_IsClassNameIs	(TObject* obj, const AnsiString& pname)
{
AnsiString	name = pname.Trim().UpperCase();
if (!obj || name.IsEmpty())	return false;

AnsiString str = AnsiString(obj->ClassName()).UpperCase();
//ShowMessage(AnsiString(str.Length()) + "<" + str + ">");
if (str == name)	return true;

for (TClass cls = TClass(obj->ClassParent()); cls; cls = cls->ClassParent())
	if (AnsiString(cls->ClassName()).UpperCase() == name)	return true;

return false;
}

//---------------------------------------------------------------------------

union	GUM_UniVar
 {	long		mint;
	double		mdouble;
//	long double	mdouble;
	bool		mbool;
	char*		mpchar;
 };

Variant	__fastcall GUM_BufferToVariant	(TField *fld, const char *ibuf, int pdsize, TGUM_DB db, bool AsString)
{
if (!fld)	return ESTRorNULL;

TNumericField	*nfld = NULL;
TDateTimeField	*dfld = NULL;
AnsiString		 fmt;
if (AsString)
 {	nfld = dynamic_cast<TNumericField*>(fld);
	dfld = dynamic_cast<TDateTimeField*>(fld);
 }

if		(nfld)	fmt = nfld->DisplayFormat;
else if	(dfld)	fmt = dfld->DisplayFormat;
else			fmt = "";

int	dsize = sizeof(GUM_UniVar);	//       
if (pdsize > dsize)	dsize = pdsize;

char	*wbuf = new char[dsize+2];	// 2   Asciz
memset (wbuf, 0x00, dsize+2);
memcpy (wbuf, ibuf, pdsize);

GUM_UniVar	*vUniVar = (GUM_UniVar*)wbuf;
Variant		 ret	 = ESTRorNULL;
try	{

switch (fld->DataType)
 {
	case ftUnknown:		break;
	case ftString:		ret = AnsiString(wbuf);
						break;

	case ftSmallint:
	case ftInteger:
	case ftWord:
						ret = vUniVar->mint;
						if (AsString)
						 {	if (fmt.IsEmpty())	fmt = "0";
							ret = FormatFloat(fmt, double(vUniVar->mint));
						 }
						break;

	case ftBoolean:		ret = vUniVar->mbool;
						if (AsString)
							ret = vUniVar->mbool? AnsiString("True") : AnsiString("False");
						break;

	case ftFloat:		ret = vUniVar->mdouble;
						if (AsString)
						 {	if (fmt.IsEmpty())	fmt = "0.0000000";
							ret = FormatFloat(fmt, vUniVar->mdouble);
						 }
						break;

	case ftDate:
	case ftTime:
	case ftDateTime:
						if (db == dbDOA)	// Oracle    
						 {	vUniVar->mdouble /= double(24*60*60*1000);
							vUniVar->mdouble += double(TDateTime(1,1,1));
							ret = TDateTime(vUniVar->mdouble - 1);
						 }
						else	ret = TDateTime(vUniVar->mdouble);
						if (AsString)
						 {	if (fmt.IsEmpty())	fmt = "dd/mm/yyyy";
							ret = FormatDateTime(fmt, ret);
						 }
						break;

	case ftCurrency:	break;
	case ftBCD:			break;
	case ftBytes:		break;
	case ftVarBytes:	break;
	case ftAutoInc:		break;
	case ftBlob:		break;
	case ftMemo:		break;
	case ftGraphic:		break;
	case ftFmtMemo:		break;
	case ftParadoxOle:	break;
	case ftDBaseOle:	break;
	case ftTypedBinary:	break;
	case ftCursor:		break;
	case ftFixedChar:	break;
	case ftWideString:	break;
	case ftLargeint:	break;
	case ftADT:			break;
	case ftArray:		break;
	case ftReference:	break;
	case ftDataSet:		break;
	case ftOraBlob:		break;
	case ftOraClob:		break;
	case ftVariant:		break;
	case ftInterface:	break;
	case ftIDispatch:	break;
	case ftGuid:		break;

	default:			break;
 }
}	// try new buf
catch (...)	{	ret = ESTRorNULL;	}
delete	[] wbuf;

return ret;
}

//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
//	DOA34      :
//	0x20      RecID (  OracleData.pas TRecordData)
//	1 	== 1 - Field is Null
//			== 0 - not is Null
//	Field->DataSize 		(  -   0  )
//---------------------------------------------------------------------------

Variant	__fastcall	GUM_GetValueFromBuffer_DOA	(TField *pfld, int rowidx, bool AsString)
{
TDataSet	*ds = pfld->DataSet;
if(	!ds || !ds->Active || (ds->State != dsBrowse) )	return ESTRorNULL;

GUM_TDataSet	*gds = (GUM_TDataSet*)ds;
char			*buf = gds->GetBuffer(rowidx);

TField	*fld = NULL;
int		 offset = 0x20;
for (int i=0; i < ds->FieldCount; i++)
 {	if ((ds->Fields->Fields[i]) == pfld)	{	fld = pfld;		break;	}
	offset += ds->Fields->Fields[i]->DataSize + 1;
 }

if (!fld)					return ESTRorNULL;
if (*(buf+offset) == 0x01)	return ESTRorNULL;

return GUM_BufferToVariant(fld, buf+offset+1, fld->DataSize, dbDOA, AsString);
}

//---------------------------------------------------------------------------
//---------------------------------------------------------------------------

Variant	__fastcall	GUM_GetValueFromBuffer_BDE	(TField *pfld, int rowidx, bool AsString)
{
return ESTRorNULL;
//         
//       Dbi  BDE    
//   (   .   )
//    Standart
//
/*
TDataSet		*ds  = pfld->DataSet;
if(	!ds || !ds->Active)	return Null;

GUM_TDataSet	*gds = (GUM_TDataSet*)ds;
char			*buf = gds->GetBuffer(rowidx);

TField	*fld = NULL;
for (int i=0; i < ds->FieldCount; i++)
	if ((ds->Fields->Fields[i]) == pfld)	{	fld = pfld;		break;	}

if (!fld)	return Null;

Variant	 ret;
BOOL	 isNull = true;
char	*databuf = new char[fld->DataSize];
try	{
	DbiGetField(((TBDEDataSet*)(ds))->Handle, fld->FieldNo, buf, databuf, isNull);
	if (isNull)	ret = ESTRorNULL;
	else		ret = GUM_BufferToVariant(fld, databuf, fld->DataSize, dbBDE, AsString);
}
catch (...)	{	ret = ESTRorNULL;	ShowMessage("error");}
delete	[] databuf;

return ret;
*/
}

//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
//	 ,   GoTo   
//---------------------------------------------------------------------------

Variant	__fastcall	GUM_GetValueFromBuffer_Any	(TField *pfld, int rowidx, int currowidx, bool AsString)
{
TDataSet		*ds  = pfld->DataSet;
if(	!ds || !ds->Active || (ds->State != dsBrowse) )	return ESTRorNULL;

Variant	 ret = ESTRorNULL;
TField	*fld = NULL;
for (int i=0; i < ds->FieldCount; i++)
	if ((ds->Fields->Fields[i]) == pfld)	{	fld = pfld;		break;	}

if (!fld)	return ESTRorNULL;

int	dlty = rowidx - currowidx;
if (dlty)
 {	ds->DisableControls();
	ds->MoveBy(dlty);
	try			{	ret = !AsString? fld->Value : Variant(fld->DisplayText);	}
	catch(...)	{	;	}
	ds->MoveBy(-dlty);
	ds->EnableControls();
 }

else	//    
 {	try			{	ret = !AsString? fld->Value : Variant(fld->DisplayText);	}
	catch(...)	{	;	}
 }

return ret;
}

//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
//	class	TGUM_GridList (  )
//---------------------------------------------------------------------------
//																 MouseMove
//---------------------------------------------------------------------------

void __fastcall	TGUM_GridList::GUM_GridList_MouseMove	(TObject *Sender, TShiftState Shift, int X, int Y)
{
if (!GUM_GridList)	return;

TDBGrid	*grd = dynamic_cast<TDBGrid*>(Sender);
if (!grd || !grd->ShowHint)	return;

TGUM_GridList_Item	*gumi = Find(grd);
if (!gumi)	return;

bool			isneed;
TGridCoord		cell = grd->MouseCoord(X,Y);
int				rowidx = cell.Y - (grd->Options.Contains(dgTitles)   ? 1 : 0);
int				clnidx = cell.X - (grd->Options.Contains(dgIndicator)? 1 : 0);

									// Hint       
if (!gumi->FieldName.IsEmpty())	isneed =  rowidx != gumi->LastRidx;
else							isneed =  rowidx != gumi->LastRidx || clnidx != gumi->LastCidx;

if (!isneed)
 {	if (gumi->OldMouseMove)	gumi->OldMouseMove(grd, Shift, X, Y);	//  MouseMove
	return;	//   
 }

//   
gumi->LastRidx = rowidx;
gumi->LastCidx = clnidx;
AnsiString	ghint = DBGrid_UnderMouse_FieldValue(grd, gumi->FieldName, true);
grd->Hint = ghint;
if (!ghint.IsEmpty())
 {
//	Application->ActivateHint(Mouse->CursorPos);
//
//	 BDE  ADO DataSet,      () 
//	    
//	   ,        
//	 Timer

	FTimer->Interval		= Application->HintPause;
	FTimer->Enabled			= true;
 }
else
 {	FTimer->Enabled			= false;
	grd->Hint = gumi->DefaultHint;
 }

if (gumi->OldMouseMove)	gumi->OldMouseMove(grd, Shift, X, Y);	//  MouseMove
}

//---------------------------------------------------------------------------
//															  
//---------------------------------------------------------------------------

void __fastcall	TGUM_GridList::OnTimerHint	(TObject* Sender)
{
FTimer->Enabled = false;
Application->ActivateHint(Mouse->CursorPos);
}

//---------------------------------------------------------------------------
//---------------------------------------------------------------------------

