//---------------------------------------------------------------------------
//	*AVC 11.08.2004			Grid Under Mouse	   
//---------------------------------------------------------------------------
#ifndef GrdUndMH
#define GrdUndMH
//---------------------------------------------------------------------------

#include "Gum_Etr.h"

#include <Classes.hpp>
#include <DB.hpp>
#include <DBGrids.hpp>

//---------------------------------------------------------------------------

class	TGUM_GridList;
TGUM_GridList	*GUM_GridList = NULL;

//---------------------------------------------------------------------------

#define	ESTRorNULL	(AsString? Variant(AnsiString("")) : Variant().AsType(varNull))

enum TGUM_DB { dbDOA, dbBDE, dbADO };

//---------------------------------------------------------------------------


bool	__fastcall	GUM_IsClassNameIs		(TObject* obj, const AnsiString& pcname);
Variant	__fastcall	GUM_BufferToVariant		(TField*  fld, const char* buf, int dsize, TGUM_DB db, bool AsString);

Variant	__fastcall	GUM_GetValueFromBuffer_DOA	(TField *fld, int rowidx, bool AsString);
Variant	__fastcall	GUM_GetValueFromBuffer_BDE	(TField *fld, int rowidx, bool AsString);
Variant	__fastcall	GUM_GetValueFromBuffer_Any	(TField *fld, int rowidx, int currowidx, bool AsString);

//---------------------------------------------------------------------------
//---------------------------------------------------------------------------

class	TGUM_GridList_Item	:	public	TObject
{
private:
	TCustomForm*	__fastcall	FindParentForm	(TWinControl *wobj)
	 {	if (!wobj)	return NULL;
		TCustomForm	*frm = dynamic_cast<TCustomForm*>(wobj);
		if (frm)	return frm;
		return	FindParentForm(wobj->Parent);
	 }

public:
	TDBGrid*		FDBGrid;
	TCustomForm*	FForm;
	AnsiString		FieldName;
	int				LastRidx;
	int				LastCidx;
	TMouseMoveEvent	OldMouseMove;
	TDateTime		LastMouseMove;
	AnsiString		DefaultHint;

	__fastcall	TGUM_GridList_Item (TDBGrid *pgrd) : System::TObject()
	 {	FDBGrid			= pgrd;
		FForm			= FindParentForm(FDBGrid);
		FieldName		= "";
		LastRidx		= -1;
		LastCidx		= -1;
		OldMouseMove	= pgrd->OnMouseMove;
		DefaultHint		= pgrd->Hint;
	 }
};

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -  - -
#pragma option push
#pragma warn -inl

class	TGUM_GridList	:	public	TComponent		//   
{
private:
	TList	*FList;

	void	__fastcall	GUM_GridList_MouseMove	(TObject *Sender, TShiftState Shift, int X, int Y);
	void	__fastcall	OnTimerHint				(TObject* Sender);

	void	__fastcall	Notification	(TComponent* AComponent, TOperation Operation)
	 {	if (Operation != opRemove || !GUM_GridList)	return;
		if (GUM_IsClassNameIs(AComponent, "TCustomForm"))
			GUM_GridList->OnDestroyForma((TCustomForm*)AComponent);
	 }

public:
	TTimer	*FTimer;

	__fastcall	TGUM_GridList (void) : TComponent(Application)
	 {	FList	= new TList();
		FTimer	= new TTimer(this);
		FTimer->Enabled		= false;
		FTimer->Interval	= 1000;
		FTimer->OnTimer		= OnTimerHint;
	 }

	__fastcall ~TGUM_GridList (void)
	 {	delete	FTimer;
		if (!FList)	return;
		TGUM_GridList_Item	*pt;
		for (int i = 0; i < FList->Count; i++)
		 {	pt = (TGUM_GridList_Item*)(FList->Items[i]);
			delete pt;
		 }
		FList->Clear();
		delete FList;
	 }

	TGUM_GridList_Item*	__fastcall	Find	(TDBGrid* pgrd)
	 {	if (!pgrd)	return NULL;
		TGUM_GridList_Item	*pt;
		for (int i = FList->Count-1; i >= 0; i--)
		 {	pt = (TGUM_GridList_Item*)(FList->Items[i]);
			if (pt->FDBGrid == pgrd)	return pt;
		 }
		return NULL;
	 }

	TGUM_GridList_Item*	__fastcall	Add	(TDBGrid* pgrd, const AnsiString& pFieldName)
	 {	if (!pgrd)	return NULL;
		TGUM_GridList_Item	*pt = Find(pgrd);
		if (!pt)
		 {	pt = new TGUM_GridList_Item(pgrd);
			FList->Add(pt);
		 }
		pt->FieldName		= pFieldName;
		pt->LastRidx		= -1;
		pt->LastCidx		= -1;
		pgrd->OnMouseMove	= GUM_GridList_MouseMove;
		return pt;
	 }

	void	__fastcall	Delete	(TDBGrid* pgrd)
	 {	TGUM_GridList_Item	*pt;
		for (int i = FList->Count-1; i >= 0; i--)
		 {	pt = (TGUM_GridList_Item*)(FList->Items[i]);
			if (pt->FDBGrid == pgrd)
			 {	pgrd->OnMouseMove	= pt->OldMouseMove;
				pgrd->Hint			= pt->DefaultHint;
				pt->FDBGrid = NULL;
				break;
			 }
		 }
	 }

	void	__fastcall	OnDestroyForma	(TCustomForm* pfrm)
	 {	if (!pfrm)	return;
		TGUM_GridList_Item	*pt;
		for (int i = FList->Count-1; i >= 0; i--)
		 {	pt = (TGUM_GridList_Item*)(FList->Items[i]);
			if (pt->FForm == pfrm)
			 {	delete pt;
				FList->Delete(i);
			 }
		 }
		FList->Pack();

/*
// *AVC 25.08.2004
//   -   TComponent (  Notification)
//     dll(bpl)     
//           
//
		if (FList->Count == 0)	// 
		 {	delete FList;
			FList = NULL;
			delete this;
			GUM_GridList = NULL;
		 }
*/
	 }
};

#pragma option pop


//---------------------------------------------------------------------------
//---------------------------------------------------------------------------

class GUM_TDataSet : public TDataSet
{
public:
	int		__fastcall	GetBufferCount	(void)		{	return TDataSet::BufferCount;	}
	char*	__fastcall	GetBuffer		(int idx)	{	return TDataSet::Buffers[idx];	}
//	virtual void __fastcall DataConvert	(TField* Field, void * Source, void * Dest, bool ToNative);
};

class GUM_TDBGrid : public TDBGrid
{
public:
			int		__fastcall	GetRow	(void)	{	return TCustomGrid::Row;	}
};


//---------------------------------------------------------------------------
#endif
